<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:04 CET 2009 -->
<TITLE>
DefaultLinAlgOperations
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.math.linalg.DefaultLinAlgOperations class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="DefaultLinAlgOperations";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/DefaultLinAlgOperations.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/GaussPivoting.html" title="interface in ch.javasoft.math.linalg"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/linalg/DefaultLinAlgOperations.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="DefaultLinAlgOperations.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#fields_inherited_from_class_ch.javasoft.math.linalg.DefaultBasicLinAlgOperations">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.math.linalg</FONT>
<BR>
Class DefaultLinAlgOperations&lt;N extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,A&gt;</H2>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg">ch.javasoft.math.linalg.DefaultBasicLinAlgOperations</A>&lt;N,A&gt;
      <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>ch.javasoft.math.linalg.DefaultLinAlgOperations&lt;N,A&gt;</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="interface in ch.javasoft.math.linalg">BasicLinAlgOperations</A>&lt;N,A&gt;, <A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;N,A&gt;</DD>
</DL>
<HR>
<DL>
<DT><PRE>public class <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.58"><B>DefaultLinAlgOperations&lt;N extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,A&gt;</B></A><DT>extends <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg">DefaultBasicLinAlgOperations</A>&lt;N,A&gt;<DT>implements <A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;N,A&gt;</DL>
</PRE>

<P>
The <code>DefaultLinAlgOperations</code> class extends 
 <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg"><CODE>DefaultBasicLinAlgOperations</CODE></A> and adds default implementations for 
 more complex linear algebra functions defined by <A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg"><CODE>LinAlgOperations</CODE></A>. 
 <p>
 An instance of this class defines the (boxed) number type and the array type, 
 such as <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Double.html" title="class or interface in java.lang"><CODE>Double</CODE></A> and <code>double[]</code>.
<P>

<P>
<HR>

<P>
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
</TABLE>
&nbsp;<A NAME="fields_inherited_from_class_ch.javasoft.math.linalg.DefaultBasicLinAlgOperations"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Fields inherited from class ch.javasoft.math.linalg.<A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg">DefaultBasicLinAlgOperations</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#arrayOps">arrayOps</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#expressionComposer">expressionComposer</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#numberArrayOps">numberArrayOps</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#numberOps">numberOps</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#DefaultLinAlgOperations(ch.javasoft.math.array.NumberArrayOperations, ch.javasoft.math.linalg.GaussPivotingFactory)">DefaultLinAlgOperations</A></B>(<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;numberArrayOps,
                                               <A HREF="../../../../ch/javasoft/math/linalg/GaussPivotingFactory.html" title="interface in ch.javasoft.math.linalg">GaussPivotingFactory</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;gaussPivotingFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#DefaultLinAlgOperations(ch.javasoft.math.array.NumberOperators, ch.javasoft.math.array.ArrayOperations, ch.javasoft.math.linalg.GaussPivotingFactory)">DefaultLinAlgOperations</A></B>(<A HREF="../../../../ch/javasoft/math/array/NumberOperators.html" title="interface in ch.javasoft.math.array">NumberOperators</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;numberOps,
                                               <A HREF="../../../../ch/javasoft/math/array/ArrayOperations.html" title="interface in ch.javasoft.math.array">ArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;arrayOps,
                                               <A HREF="../../../../ch/javasoft/math/linalg/GaussPivotingFactory.html" title="interface in ch.javasoft.math.linalg">GaussPivotingFactory</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;gaussPivotingFactory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#invertMatrix(A[], int[], int[])">invertMatrix</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                         int[]&nbsp;rowmap,
                         int[]&nbsp;colmap)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes and returns the inverse of the given square <code>matrix</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#invertMaximalSubmatrix(A[], int[], int[], int[])">invertMaximalSubmatrix</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                                             int[]&nbsp;rowmap,
                                             int[]&nbsp;colmap,
                                             int[]&nbsp;ptrRank)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes the inverse of a submatrix of a non-square or singular square 
 matrix.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#kernel(A[], int[], int[], int[])">kernel</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
             int[]&nbsp;rowmap,
             int[]&nbsp;colmap,
             int[]&nbsp;ptrNullity)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes a basis for the nullspace using by computing the reduced 
 row-echelon form of the input matrix.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#nullity(A[])">nullity</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes and returns the nullity of the given matrix, associated with
 rank deficiency.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#rank(A[])">rank</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes and returns the rank of the given matrix</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#rowEchelon(A[], A[], boolean, int[], int[])">rowEchelon</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;src,
                     <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;dst,
                     boolean&nbsp;reduced,
                     int[]&nbsp;rowmap,
                     int[]&nbsp;colmap)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Transforms the <code>src</code> matrix into row echelon form using Gaussian 
 elimination, writing the transformed matrix to <code>dst</code> and returning
 the rank of the matrix.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html#rowEchelon(A[], boolean, int[], int[], int[])">rowEchelon</A></B>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                     boolean&nbsp;reduced,
                     int[]&nbsp;rowmap,
                     int[]&nbsp;colmap,
                     int[]&nbsp;ptrRank)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Transforms the <code>matrix</code> into row echelon form using Gaussian 
 elimination and returns the transformed matrix.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_ch.javasoft.math.linalg.DefaultBasicLinAlgOperations"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class ch.javasoft.math.linalg.<A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg">DefaultBasicLinAlgOperations</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#abs(A)">abs</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#abs(A[])">abs</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#add(A[], A[])">add</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#add(A, A)">add</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#arrayClass()">arrayClass</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#divideElementByElement(A[], A[])">divideElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#divideElementByElement(A, A)">divideElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#get(A[], int, int)">get</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#get(A, int)">get</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#getArrayOperations()">getArrayOperations</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#getConverterFrom(ch.javasoft.math.array.NumberArrayOperations)">getConverterFrom</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#getConverterTo(ch.javasoft.math.array.NumberArrayOperations)">getConverterTo</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#getExpressionComposer()">getExpressionComposer</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#getNumberArrayOperations()">getNumberArrayOperations</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#getNumberOperators()">getNumberOperators</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiply(A[], A)">multiply</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiply(A[], A[])">multiply</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiply(A, A[])">multiply</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiplyElementByElement(A[], A[])">multiplyElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiplyElementByElement(A, A)">multiplyElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiplyInner(A, A)">multiplyInner</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#multiplyOuter(A, A)">multiplyOuter</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#negate(A)">negate</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#negate(A[])">negate</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#numberClass()">numberClass</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#signum(A[], int, int)">signum</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#signum(A, int)">signum</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#subtract(A[], A[])">subtract</A>, <A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html#subtract(A, A)">subtract</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_ch.javasoft.math.linalg.BasicLinAlgOperations"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from interface ch.javasoft.math.linalg.<A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html" title="interface in ch.javasoft.math.linalg">BasicLinAlgOperations</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#abs(A)">abs</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#abs(A[])">abs</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#add(A[], A[])">add</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#add(A, A)">add</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#arrayClass()">arrayClass</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#divideElementByElement(A[], A[])">divideElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#divideElementByElement(A, A)">divideElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#get(A[], int, int)">get</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#get(A, int)">get</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getArrayOperations()">getArrayOperations</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getConverterFrom(ch.javasoft.math.array.NumberArrayOperations)">getConverterFrom</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getConverterTo(ch.javasoft.math.array.NumberArrayOperations)">getConverterTo</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getExpressionComposer()">getExpressionComposer</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getNumberArrayOperations()">getNumberArrayOperations</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#getNumberOperators()">getNumberOperators</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiply(A[], A)">multiply</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiply(A[], A[])">multiply</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiply(A, A[])">multiply</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyElementByElement(A[], A[])">multiplyElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyElementByElement(A, A)">multiplyElementByElement</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyInner(A, A)">multiplyInner</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#multiplyOuter(A, A)">multiplyOuter</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#negate(A)">negate</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#negate(A[])">negate</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#numberClass()">numberClass</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#signum(A[], int, int)">signum</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#signum(A, int)">signum</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#subtract(A[], A[])">subtract</A>, <A HREF="../../../../ch/javasoft/math/linalg/BasicLinAlgOperations.html#subtract(A, A)">subtract</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="DefaultLinAlgOperations(ch.javasoft.math.array.NumberOperators, ch.javasoft.math.array.ArrayOperations, ch.javasoft.math.linalg.GaussPivotingFactory)"><!-- --></A><H3>
DefaultLinAlgOperations</H3>
<PRE>
public <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.71"><B>DefaultLinAlgOperations</B></A>(<A HREF="../../../../ch/javasoft/math/array/NumberOperators.html" title="interface in ch.javasoft.math.array">NumberOperators</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;numberOps,
                               <A HREF="../../../../ch/javasoft/math/array/ArrayOperations.html" title="interface in ch.javasoft.math.array">ArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;arrayOps,
                               <A HREF="../../../../ch/javasoft/math/linalg/GaussPivotingFactory.html" title="interface in ch.javasoft.math.linalg">GaussPivotingFactory</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;gaussPivotingFactory)</PRE>
<DL>
</DL>
<HR>

<A NAME="DefaultLinAlgOperations(ch.javasoft.math.array.NumberArrayOperations, ch.javasoft.math.linalg.GaussPivotingFactory)"><!-- --></A><H3>
DefaultLinAlgOperations</H3>
<PRE>
public <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.74"><B>DefaultLinAlgOperations</B></A>(<A HREF="../../../../ch/javasoft/math/array/NumberArrayOperations.html" title="interface in ch.javasoft.math.array">NumberArrayOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;numberArrayOps,
                               <A HREF="../../../../ch/javasoft/math/linalg/GaussPivotingFactory.html" title="interface in ch.javasoft.math.linalg">GaussPivotingFactory</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;&nbsp;gaussPivotingFactory)</PRE>
<DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="kernel(java.lang.Object,int,int,int)"><!-- --></A><A NAME="kernel(A[], int[], int[], int[])"><!-- --></A><H3>
kernel</H3>
<PRE>
public <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.88"><B>kernel</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                  int[]&nbsp;rowmap,
                  int[]&nbsp;colmap,
                  int[]&nbsp;ptrNullity)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#kernel(A[], int[], int[], int[])">LinAlgOperations</A></CODE></B></DD>
<DD>Computes a basis for the nullspace using by computing the reduced 
 row-echelon form of the input matrix. The reduced row echelon matrix has 
 structure [ I, M ; 0 ], thus the kernel matrix is simply [ -M ; I ].
 <p>
 Note that rows and columns might be swapped due to pivoting. The row and 
 column permutations are returned in <code>rowmap</code> and <code>colmap</code> if 
 not null.
 <p>
 The rank       of -- or number of columns in -- the returned matrix is returned 
 in <code>ptrNullity[0]</code> if not null. Note that the nullity is not 
 necessarily equal to the nullity of the whole matrix, since the lengths 
 of <code>rowmap</code> and <code>colmap</code> might limit the allowed pivot rows 
 and columns.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#kernel(A[], int[], int[], int[])">kernel</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the input matrix<DD><CODE>rowmap</CODE> - the row mapping (out parameter), if not null, the row
                                        indices are filled in which have been used to produce 
                                        the row echelon matrix form. The mapping is only used as 
                                        out parameter, but its length determines how many rows 
                                        to use as pivot rows. If null, all rows are pivot 
                                        candidates<DD><CODE>colmap</CODE> - the column mapping (out parameter), if not null, the 
                                        column indices are filled in which have been used to 
                                        to produce the row echelon matrix form. The mapping is 
                                        only used as out parameter, but its length determines 
                                        how many columns to use as pivot columns. If null, all
                                        columns are pivot candidates<DD><CODE>ptrNullity</CODE> - if not null, <code>ptrNullity[0]</code> will contain the 
                                        nullity, that is, the rank of the returned kernel 
                                        matrix. Note that this is not necessarily equal to the 
                                        nullity of the whole matrix, since the lengths of 
                                        <code>rowmap</code> and <code>colmap</code> might limit the 
                                        allowed pivot rows and columns.
<DT><B>Returns:</B><DD>the kernel, a basis for the nullspace</DL>
</DD>
</DL>
<HR>

<A NAME="invertMatrix(java.lang.Object,int,int)"><!-- --></A><A NAME="invertMatrix(A[], int[], int[])"><!-- --></A><H3>
invertMatrix</H3>
<PRE>
public <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.178"><B>invertMatrix</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                        int[]&nbsp;rowmap,
                        int[]&nbsp;colmap)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#invertMatrix(A[], int[], int[])">LinAlgOperations</A></CODE></B></DD>
<DD>Computes and returns the inverse of the given square <code>matrix</code>. The
 product of the returned matrix <code>inv(matrix)</code> with the matrix 
 results in an identity matrix, that is,
 <code>inv(matrix) * matrix = matrix * inv(matrix) = I</code>.
 <p>
 Note that rows and columns might be swapped due to pivoting. The row and 
 column permutations are returned in <code>rowmap</code> and <code>colmap</code> if 
 not null.
 <p>
 If integer division is not supported
 (see <A HREF="../../../../ch/javasoft/math/array/NumberOperators.html#getDivisionSupport()"><CODE>NumberOperators.getDivisionSupport()</CODE></A>), the product of the
 inverse matrix and the matrix does not yield an identity matrix, but a
 matrix that contains only positive diagonal elements. More formally, if 
 division is not supported, the inverse <code>inv(M)</code> of a matrix 
 <code>M</code> is defined such that
 <pre>inv(M) * M = diag , diag(i,i) > 0, diag(i,j) = 0 if i &ne; j</pre>
 where <code>diag</code> is a diagonal matrix.
 <p>
 The method used is computing the reduced row-echelon form of the matrix
 [mx I], ending up in a matrix [I inv(mx)].
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#invertMatrix(A[], int[], int[])">invertMatrix</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix from which submatrix of maximal rank is taken
                                        and inverted<DD><CODE>rowmap</CODE> - the row mapping (out parameter), if not null, the row
                                        indices are filled in which have been used to produce 
                                        the row echelon matrix form. The mapping is only used as 
                                        out parameter, but its length determines how many rows 
                                        to use as pivot rows. If null, all rows are pivot 
                                        candidates<DD><CODE>colmap</CODE> - the column mapping (out parameter), if not null, the 
                                        column indices are filled in which have been used to 
                                        to produce the row echelon matrix form. The mapping is 
                                        only used as out parameter, but its length determines 
                                        how many columns to use as pivot columns. If null, all
                                        columns are pivot candidates
<DT><B>Returns:</B><DD>the inverted matrix</DL>
</DD>
</DL>
<HR>

<A NAME="invertMaximalSubmatrix(java.lang.Object,int,int,int)"><!-- --></A><A NAME="invertMaximalSubmatrix(A[], int[], int[], int[])"><!-- --></A><H3>
invertMaximalSubmatrix</H3>
<PRE>
public <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.189"><B>invertMaximalSubmatrix</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                                  int[]&nbsp;rowmap,
                                  int[]&nbsp;colmap,
                                  int[]&nbsp;ptrRank)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#invertMaximalSubmatrix(A[], int[], int[], int[])">LinAlgOperations</A></CODE></B></DD>
<DD>Computes the inverse of a submatrix of a non-square or singular square 
 matrix. The submatrix row/column size is determined by the rank of the
 matrix. For instance, for a rectangular matrix A with m rows and n 
 columns and n = rank(A) and m > n, a submatrix with n rows is chosen,
 such that the submatrix has full rank. The chosen columns and rows are
 returned in rowmap/colmap.
 <p>
 Note that if integer division is not supported
 (see <A HREF="../../../../ch/javasoft/math/array/NumberOperators.html#getDivisionSupport()"><CODE>NumberOperators.getDivisionSupport()</CODE></A>), the product of the
 inverse matrix and the matrix does not yield an identity matrix, but a
 matrix that contains only positive diagonal elements. More formally, if 
 division is not supported, the inverse <code>inv(M)</code> of a matrix 
 <code>M</code> is defined such that
 <pre>inv(M) * M = diag , diag(i,i) > 0, diag(i,j) = 0 if i &ne; j</pre>
 where <code>diag</code> is a diagonal matrix.
 <p>
 The method used is computing the reduced row-echelon form of the matrix
 [mx I], ending up in a matrix [I inv(mx)].
 <p>
 Note that the returned rank is not necessarily equal to the rank of the 
 whole matrix, since the lengths of <code>rowmap</code> and <code>colmap</code> 
 might limit the allowed pivot rows and columns.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#invertMaximalSubmatrix(A[], int[], int[], int[])">invertMaximalSubmatrix</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix from which submatrix of maximal rank is taken
                                        and inverted<DD><CODE>rowmap</CODE> - the row mapping (out parameter), if not null, the row
                                        indices are filled in which have been used to produce 
                                        the row echelon matrix form. The mapping is only used as 
                                        out parameter, but its length determines how many rows 
                                        to use as pivot rows. If null, all rows are pivot 
                                        candidates<DD><CODE>colmap</CODE> - the column mapping (out parameter), if not null, the 
                                        column indices are filled in which have been used to 
                                        to produce the row echelon matrix form. The mapping is 
                                        only used as out parameter, but its length determines 
                                        how many columns to use as pivot columns. If null, all
                                        columns are pivot candidates<DD><CODE>ptrRank</CODE> - if not null, <code>ptrRank[0]</code> will contain the rank
                                        of the returned matrix. Note that this is not 
                                        necessarily equal to the rank of the whole matrix, since 
                                        the lengths of <code>rowmap</code> and <code>colmap</code> might 
                                        limit the allowed pivot rows and columns.
<DT><B>Returns:</B><DD>the inverted (sub)matrix, always square</DL>
</DD>
</DL>
<HR>

<A NAME="nullity(java.lang.Object)"><!-- --></A><A NAME="nullity(A[])"><!-- --></A><H3>
nullity</H3>
<PRE>
public int <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.229"><B>nullity</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#nullity(A[])">LinAlgOperations</A></CODE></B></DD>
<DD>Computes and returns the nullity of the given matrix, associated with
 rank deficiency. The nullity is the rank of the nullspace of the matrix,
 thus, nullity is the number of matrix columns minus rank.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#nullity(A[])">nullity</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix
<DT><B>Returns:</B><DD>the nullity of the matrix, the rank of the nullspace</DL>
</DD>
</DL>
<HR>

<A NAME="rank(java.lang.Object)"><!-- --></A><A NAME="rank(A[])"><!-- --></A><H3>
rank</H3>
<PRE>
public int <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.236"><B>rank</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#rank(A[])">LinAlgOperations</A></CODE></B></DD>
<DD>Computes and returns the rank of the given matrix
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#rank(A[])">rank</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix
<DT><B>Returns:</B><DD>the rank of the matrix</DL>
</DD>
</DL>
<HR>

<A NAME="rowEchelon(java.lang.Object,boolean,int,int,int)"><!-- --></A><A NAME="rowEchelon(A[], boolean, int[], int[], int[])"><!-- --></A><H3>
rowEchelon</H3>
<PRE>
public <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[] <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.243"><B>rowEchelon</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;matrix,
                      boolean&nbsp;reduced,
                      int[]&nbsp;rowmap,
                      int[]&nbsp;colmap,
                      int[]&nbsp;ptrRank)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#rowEchelon(A[], boolean, int[], int[], int[])">LinAlgOperations</A></CODE></B></DD>
<DD>Transforms the <code>matrix</code> into row echelon form using Gaussian 
 elimination and returns the transformed matrix. The row echelon form
 has the form <code>[ I , M ; 0]</code> or <code>[ [I ; M] , 0]</code>, depending
 on dimensions and rank. 
 <p>
 If integer division is not supported
 (see <A HREF="../../../../ch/javasoft/math/array/NumberOperators.html#getDivisionSupport()"><CODE>NumberOperators.getDivisionSupport()</CODE></A>), the diagonal of the
 identity part might contain positive values different from one.  
 <p>
 Note that rows and columns might be swapped due to pivoting. The row and 
 column permutations are returned in <code>colmap</code> and <code>colmap</code> if 
 not null. 
 <p>
 The rank       of -- or number of ones in -- the identity part of the returned 
 matrix is returned in <code>ptrRank[0]</code> if not null. Note that the rank 
 is not necessarily equal to the rank of the whole matrix, since the 
 lengths of <code>rowmap</code> and <code>colmap</code> might limit the allowed 
 pivot rows and columns.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#rowEchelon(A[], boolean, int[], int[], int[])">rowEchelon</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>matrix</CODE> - the matrix to reduce<DD><CODE>reduced</CODE> - if true, the reduced row echelon form is produced, 
                                        also resulting in zeros above the diagonal<DD><CODE>rowmap</CODE> - the row mapping (out parameter), if not null, the row
                                        indices are filled in which have been used to produce 
                                        the row echelon matrix form. The mapping is only used as 
                                        out parameter, but its length determines how many rows 
                                        to use as pivot rows. If null, all rows are pivot 
                                        candidates<DD><CODE>colmap</CODE> - the column mapping (out parameter), if not null, the 
                                        column indices are filled in which have been used to 
                                        to produce the row echelon matrix form. The mapping is 
                                        only used as out parameter, but its length determines 
                                        how many columns to use as pivot columns. If null, all
                                        columns are pivot candidates<DD><CODE>ptrRank</CODE> - if not null, <code>ptrRank[0]</code> will contain the rank
                                        of -- or number of ones in -- the identity part of the 
                                        returned matrix. Note that this is not necessarily equal
                                        to the rank of the whole matrix, since the lengths of 
                                        <code>rowmap</code> and <code>colmap</code> might limit the 
                                        allowed pivot rows and columns.
<DT><B>Returns:</B><DD>the matrix in row echelon form</DL>
</DD>
</DL>
<HR>

<A NAME="rowEchelon(java.lang.Object,java.lang.Object,boolean,int,int)"><!-- --></A><A NAME="rowEchelon(A[], A[], boolean, int[], int[])"><!-- --></A><H3>
rowEchelon</H3>
<PRE>
public int <A HREF="../../../../src-html/ch/javasoft/math/linalg/DefaultLinAlgOperations.html#line.254"><B>rowEchelon</B></A>(<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;src,
                      <A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>[]&nbsp;dst,
                      boolean&nbsp;reduced,
                      int[]&nbsp;rowmap,
                      int[]&nbsp;colmap)</PRE>
<DL>
<DD><B>Description copied from interface: <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#rowEchelon(A[], A[], boolean, int[], int[])">LinAlgOperations</A></CODE></B></DD>
<DD>Transforms the <code>src</code> matrix into row echelon form using Gaussian 
 elimination, writing the transformed matrix to <code>dst</code> and returning
 the rank of the matrix. The row echelon form
 has the form <code>[ I , M ; 0]</code> or <code>[ [I ; M] , 0]</code>, depending
 on dimensions and rank. 
 <p>
 If integer division is not supported
 (see <A HREF="../../../../ch/javasoft/math/array/NumberOperators.html#getDivisionSupport()"><CODE>NumberOperators.getDivisionSupport()</CODE></A>), the diagonal of the
 identity part might contain positive values different from one.  
 <p>
 Note that rows and columns might be swapped due to pivoting. The row and 
 column permutations are returned in <code>rowmap</code> and <code>colmap</code> if 
 not null.
 <p>
 Note that the returned rank is not necessarily equal to the rank of the 
 whole matrix, since the lengths of <code>rowmap</code> and <code>colmap</code> 
 might limit the allowed pivot rows and columns.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html#rowEchelon(A[], A[], boolean, int[], int[])">rowEchelon</A></CODE> in interface <CODE><A HREF="../../../../ch/javasoft/math/linalg/LinAlgOperations.html" title="interface in ch.javasoft.math.linalg">LinAlgOperations</A>&lt;<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">N</A> extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Number.html" title="class or interface in java.lang">Number</A>,<A HREF="../../../../ch/javasoft/math/linalg/DefaultLinAlgOperations.html" title="type parameter in DefaultLinAlgOperations">A</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>src</CODE> - the matrix to reduce<DD><CODE>dst</CODE> - the destination matrix for the results<DD><CODE>reduced</CODE> - if true, the reduced row echelon form is produced, 
                                        also resulting in zeros above the diagonal<DD><CODE>rowmap</CODE> - the row mapping (out parameter), if not null, the row
                                        indices are filled in which have been used to produce 
                                        the row echelon matrix form. The mapping is only used as 
                                        out parameter, but its length determines how many rows 
                                        to use as pivot rows. If null, all rows are pivot 
                                        candidates<DD><CODE>colmap</CODE> - the column mapping (out parameter), if not null, the 
                                        column indices are filled in which have been used to 
                                        to produce the row echelon matrix form. The mapping is 
                                        only used as out parameter, but its length determines 
                                        how many columns to use as pivot columns. If null, all
                                        columns are pivot candidates
<DT><B>Returns:</B><DD>the rank of the matrix</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/DefaultLinAlgOperations.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/DefaultBasicLinAlgOperations.html" title="class in ch.javasoft.math.linalg"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/linalg/GaussPivoting.html" title="interface in ch.javasoft.math.linalg"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/linalg/DefaultLinAlgOperations.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="DefaultLinAlgOperations.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#fields_inherited_from_class_ch.javasoft.math.linalg.DefaultBasicLinAlgOperations">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
